
<p>Na ovoj stranici pogledat ćemo kako se ostvaruje sklop koji obavlja funkciju logičko-NE: invertor. Pokazat ćemo izvedbu u bipolarnoj tehnologiji (NPN-tranzistorom), potom uporabom n-kanalnog MOSFET-a i konačno uporabom tehnologije CMOS.</p>

<h3>Invertor uporabom bipolarne tehnologije</h3>

<p>Invertor ostvarujemo kao sklop arhitekture kod koje je izlaz pritegnut na napajanje a bipolarni NPN-tranzistor realizira sklopku. Shema je prikazana u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(inv-bip.svg)" alt="Invertor u bipolarnoj tehnologiji."><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Invertor u bipolarnoj tehnologiji.</figcaption>
</figure>

<p>Prisjetite se kako se ponaša NPN-tranzistor. Kad mu je na bazi napon dovoljno visok (i kada je bazna struja određena baznim otporom \(R_B\) dovoljno velika), tranzistor će se uključiti i otpor između kolektora i emitera će biti vrlo mali, pa se između priključaka C i E tranzistor ponaša kao uključena sklopka. S druge trane, nedovoljno visok napon na bazi tranzistora isti će isključiti pa će se tranzistor ponašati kao isključena sklopka: otpor između konektora C i E bit će vrlo visok (idealno, beskonačan).</p>

<p>Tablica kombinacija naponskih razina koja se dobiva za ovaj sklop prikazana je u nastavku.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica naponskih kombinacija</div>
<table class="mlTableCC mlTableVR2">
<thead>
<tr><th><i>U<sub>A</sub></i></th><th><i>U<sub>f</sub></i></th></tr>
</thead>
<tbody>
<tr><td>N</td><td>V</td></tr>
<tr><td>V</td><td>N</td></tr>
</tbody>
</table>

<p>Booleova funkcija koja je definirana ove prikazana je tablicom istinitosti u nastavku, i jasno je da se radi o funkciji \(f(A) =\bar A\).

<div class="mlTableCaption"><span class="mlTblKey">Tablica 2.</span> Pripadna tablica istinitosti</div>
<table class="mlTableCC mlTableVR2">
<thead>
<tr><th><i>A</i></th><th><i>f</i></th></tr>
</thead>
<tbody>
<tr><td>0</td><td>1</td></tr>
<tr><td>1</td><td>0</td></tr>
</tbody>
</table>

<script>
@#page-include#(Utility.js)
@#page-include#(InverterCircuits.js)
@#page-include#(UnaryTruthTable.js)
</script>

<p>
Interaktivna simulacija invertora ostvarenog bipolarnim NPN-tranzistorom prikazana je u nastavku. Klikom na zasivljenu pločicu na ulazu možete mijenjati logičku 
vrijednost koja se dovodi na ulaz sklopa. Isprobajte sljedeće.
</p>

<ol class="mlSpread">
<li>Postavite na ulaz logičku nulu. Tada je ulaz kratko spojen na masu. Potencijal ulazne pločice je 0V pa baznim strujnim krugom ne teče struja. Pad napona na baznom otporniku kao
i na spoju baza-emiter iznosi 0V. Tranzistor je blokiran pa spoj kolektor-emiter predstavlja beskonačan otpor. U izlaznom strujnom krugu stoga od izvora napajanja kroz
kolektorski otpornik i potom spoj kolektor-emiter struja ne teče. Cjelokupni napon napajanja troši se na spoju kolektor-emiter što ujedno čini i izlazni napon sklopa.</li>
<li>Postavite na ulaz logičku jedinicu. Tada je ulaz spojen na izvor napajanja iznosa 5V (u ovom primjeru). Baznim strujnim krugom sada teče struja (shema je animirana pa ćete
uočiti smjer toka struje: od izvora spojenog na ulaz kroz bazni otpornik te kroz spoj baza-emiter tranzistora pa prema masi). Ulazni napon troši se na seriji
dvaju otpora u baznom krugu: baznog otpornika te otpora koji predstavlja spoj baza-emiter tranzistora. Kako će na spoju baza-emiter uvijek vladati napon blizak 0,7V, preostalih
\(5V-0,7V=4,3V\) troši se na baznom otporniku (zahvaljujući čemu je lagano izračunati i stvarni iznos te struje, kada bismo znali točan iznos baznog otpornika). U ovom slučaju tranzistor
je uključen i kroz izlazni strujni krug također teče struja (pogledajte animaciju). Otpor spoja kolektor-emiter sada je relativno malen i na njemu vlada napon zasićenja tranzistora koji 
je poprilici 0,3V. Kako je u izlaznom strujnom krugu napon napajanja doveden na seriju kolektorskog otpornika i spoja kolektor-emiter tranzistora, ostatak napona, 
\(5V - 0,3V = 4,7V\) se troši na kolektorskom otporniku. Izlazni napon sklopa jednak je naponu spoja kolektor-emiter pa on u ovom slučaju iznosi svega 0,3V, što tumačimo kao logičku 0.</li>
</ol>

<div style="text-align: center;">
<canvas id="NPNInverterCanvas" width="500" height="300" style="border: solid 1px black"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Leon Luttenberger</span>
</div>

<script>
(function(){
    var canvas = document.getElementById("NPNInverterCanvas");
    var context = canvas.getContext("2d");

    var circuit = new NPNInverterCircuit(0, 5, 4.3, 0.3);
    var truthTable = new TruthTable('1', '0', true);
    var input;

    var lineLength = 30;
    var inputSize = 25;
    var fontSize = 18;

    repaint();

    canvas.addEventListener("click", function (e) {
        var pos = getMousePos(canvas, e);

        if (input.containsPoint(pos.x, pos.y)) {
            circuit.setInput(!circuit.input);
            repaint();
        }
    }, false);

    function repaint() {
        context.clearRect(0, 0, canvas.width, canvas.height);

        context.beginPath();
        circuit.draw(context, 100, 25, 150, 250, true);

        context.beginPath();
        context.moveTo(circuit.inputConnector.x, circuit.inputConnector.y);
        context.lineTo(circuit.inputConnector.x - lineLength, circuit.inputConnector.y);
        context.stroke();

        var x = circuit.inputConnector.x - lineLength - inputSize;
        input = new Rectangle(x, circuit.inputConnector.y - inputSize / 2, inputSize, inputSize);

        context.strokeStyle = "black";
        context.fillStyle = "gray";
        context.textBaseline = "middle";
        context.textAlign = "center";

        context.beginPath();
        input.draw(context, true);

        context.fillStyle = "black";
        context.font =  fontSize + 'px Arial';

        var value = circuit.input ? 1 : 0;
        context.fillText(
                value + '',
                input.x + input.width / 2,
                input.y + input.height / 2
        );

        context.textAlign = "center";
        context.textBaseline = "bottom";
        context.fillText("A", circuit.inputConnector.x - lineLength / 2, circuit.inputConnector.y - 5);

        context.textAlign = "left";
        context.textBaseline = "middle";
        context.fillText(
                "f=" + (circuit.output ? '1' : '0'),
                circuit.outputConnector.x + 5,
                circuit.outputConnector.y
        );

        var selectedRow = circuit.input ? 1 : 0;
        context.beginPath();
        truthTable.draw(context, 325, 40, 150, 125, selectedRow);
    }

    canvas.addEventListener("click", function (e) {
        var pos = getMousePos(canvas, e);

        if (circuit.transistorRectangle.containsPoint(pos.x, pos.y)) {
            circuit.setInput(!circuit.input);
            repaint();
        }

    }, false);
})();
</script>

<h3>Invertor uporabom tehnologije MOSFET</h3>

<p>Invertor ostvarujemo uporabom n-kanalnog MOSFET-a kao sklop arhitekture kod koje je izlaz pritegnut na napajanje a tranzistor realizira sklopku. Shema je prikazana u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(inv-nmos.svg)" alt="Konceptualna izvedba invertora uporabom n-kanalnog MOSFET-a."><br>
<figcaption><span class="mlFigKey">Slika 2.</span> Konceptualna izvedba invertora uporabom n-kanalnog MOSFET-a.</figcaption>
</figure>

<p>Tehnološki, kako je otpor otpornika proporcionalan njegovoj duljini, pri proizvodnji integriranih sklopovima izravna implementacija bi trošila dosta mjesta na čipu. Iz tog razloga umjesto otpornika u gornju se granu stavlja još jedan n-kanalni MOSFET čija je upravljačka elektroda konstantno spojena na visok napon pa je taj tranzistor uvijek uključen, a proizveden je tako da se ponaša kao relativno loša sklopka koja, kad je uključena, ima otpor od poprilici 100 k&#x2126;. Ova realizacija prikazana je na slici 3.</p>

<figure class="mlFigure">
<img src="@#file#(inv-nmos2.svg)" alt="Izvedba invertora uporabom n-kanalnog MOSFET-a."><br>
<figcaption><span class="mlFigKey">Slika 3.</span> Izvedba invertora uporabom n-kanalnog MOSFET-a.</figcaption>
</figure>

<p>Pripadna tablica kombinacija naponskih razina te tablica istinitosti jednake su tablicama 1 i 2. Sklop ostvaruje funkciju invertora.</p> 

<p>Interaktivna demonstracija ovakvog invertora dana je u nastavku. Isprobajte je. Kako se MOSFET-tranzistori tehnološki ostvaruju drugačije u odnosu na bipolarne tranzistore,
upravljačka elektroda ponaša se kao jedna ploča kondenzatora (pogledajte i sam simbol tranzistora - podsjeća na dvije ploče kondenzatora, samo što desnu crtamo malo dužom). Stoga 
taj put za struju predstavlja beskonačan otpor pa ulaznim strujnim krugom struja nikada ne teče (ako se
napon na ulazu često mijenja, tada će tim strujnim krugom ipak teči struja jer će se "kondenzator" nabijati i izbijati; u takvom režimu u ulazni se krug može staviti otpornik
koji će ograničiti tu struju; ove efekte, međutim, na ovom principijelnom prikazu rada sklopa nećemo razmatrati).</p>

<div style="text-align: center;">
<canvas id="NMOSInverterCanvas" width="500" height="300" style="border: solid 1px black"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Leon Luttenberger</span>
</div>

<script>
(function(){
    var canvas = document.getElementById("NMOSInverterCanvas");
    var context = canvas.getContext("2d");

    var circuit = new NMOSInverterCircuit(0, 5, 0.1);
    var truthTable = new TruthTable('1', '0', true);
    var input;

    var lineLength = 30;
    var inputSize = 25;
    var fontSize = 18;

    repaint();

    canvas.addEventListener("click", function (e) {
        var pos = getMousePos(canvas, e);

        if (input.containsPoint(pos.x, pos.y)) {
            circuit.setInput(!circuit.input);
            repaint();
        }
    }, false);

    function repaint() {
        context.clearRect(0, 0, canvas.width, canvas.height);

        context.beginPath();
        circuit.draw(context, 100, 25, 150, 250, true);

        context.beginPath();
        context.moveTo(circuit.inputConnector.x, circuit.inputConnector.y);
        context.lineTo(circuit.inputConnector.x - lineLength, circuit.inputConnector.y);
        context.stroke();

        var x = circuit.inputConnector.x - lineLength - inputSize;
        input = new Rectangle(x, circuit.inputConnector.y - inputSize / 2, inputSize, inputSize);

        context.strokeStyle = "black";
        context.fillStyle = "gray";
        context.textBaseline = "middle";
        context.textAlign = "center";

        context.beginPath();
        input.draw(context, true);

        context.fillStyle = "black";
        context.font =  fontSize + 'px Arial';

        var value = circuit.input ? 1 : 0;
        context.fillText(
                value + '',
                input.x + input.width / 2,
                input.y + input.height / 2
        );

        context.textAlign = "center";
        context.textBaseline = "bottom";
        context.fillText("A", circuit.inputConnector.x - lineLength / 2, circuit.inputConnector.y - 5);

        context.textAlign = "left";
        context.textBaseline = "middle";
        context.fillText(
                "f=" + (circuit.output ? '1' : '0'),
                circuit.outputConnector.x + 5,
                circuit.outputConnector.y
        );

        var selectedRow = circuit.input ? 1 : 0;
        context.beginPath();
        truthTable.draw(context, 325, 40, 150, 125, selectedRow);
    }

    canvas.addEventListener("click", function (e) {
        var pos = getMousePos(canvas, e);

        if (circuit.transistorRectangle.containsPoint(pos.x, pos.y)) {
            circuit.setInput(!circuit.input);
            repaint();
        }

    }, false);
})();
</script>

<p>Primijetite simbol n-kanalnog MOSFET tranzistora koji je korišten na slici 2 odnosno u prethodnoj simulaciji. Razlika je u docrtanoj strelici. Simbol korišten na slici 2 predstavlja
   "logički" simbol tranzistora dok onaj prikazan u simulaciji predstavlja inačicu koja je bliža elektroničkoj implementaciji.</p>

<h3>Invertor uporabom tehnologije CMOS</h3>

<p>Tehnologija CMOS koristi obje vrste MOSFET tranzistora - p-kanalne i n-kanalne. Funkcioniranje n-kanalnog MOSFET-a objašnjeno je u drugoj minilekciji koju ste već trebali usvojiti. p-kanalni MOSFET se ponaša slično - samo obrnuto: on je uključen kada mu je na upravljačkoj elektrodi nizak napon dok ga visok napon isključuje (blokira). Simbol mu je sličan simbolu n-kanalnog MOSFET-a; razlika je što se uz upravljačku elektrodu dodaje kružić koji nas upozorava na ovo obrnuto ponašanje.</p>

<p>U tehnologiji CMOS, invertor ostvarujemo kao sklop arhitekture kod koje je izlaz zasebnim sklopkama spojen i na napajanje i na masu. Kod ove se tehnologije p-kanalni MOSFET-i uvijek koriste za spajanje izlaza na napajanje, a n-kanalni za spajanje izlaza na masu. Shema je prikazana u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(inv-cmos.svg)" alt="Izvedba invertora uporabom tehnologije CMOS."><br>
<figcaption><span class="mlFigKey">Slika 4.</span> Izvedba invertora uporabom tehnologije CMOS.</figcaption>
</figure>

<p>Pripadna tablica kombinacija naponskih razina te tablica istinitosti jednake su tablicama 1 i 2. Sklop ostvaruje funkciju invertora.</p>

<p>Uočite kako korišteni par tranzistora osigurava da nikada nisu uključene obje sklopke. Ako je ulazni napon nizak, uključen je p-kanalni MOSFET (Tr1) koji izlaz povezuje na napajanje dok je n-kanalni MOSFET (Tr2) isključen (pa je veza izlaza prema masi prekinuta). Izlazni napon stoga je visok. Ako je ulazni napon visok, uključen je n-kanalni MOSFET (Tr2) koji izlaz povezuje na masu dok je p-kanalni MOSFET (Tr1) isključen (pa je veza izlaza prema napajanju prekinuta). U ovom slučaju, izlazni napon je nizak.</p> 

<p>Opisano ponašanje možete isprobati u interaktivnoj simulaciji u nastavku. Klikom na zasivljenu pločicu koja definira logičku (i naponsku) vrijednost koja se dovodi na upravljačke ulaze
   MOSFET-tranzistora možete odrediti želite li da na ulazu bude logičko 0 (0V) ili logičko 1 (5V). Tranzistor koji je onemogućen, bit će prikazan zasivljeno. Između njegovog uvoda i odvoda 
   (engl. <i>source</i> te engl. <i>drain</i>) bit će vrlo veliki otpor (pravimo se - beskonačan), pa će se sav pad napona distribuirati upravo na taj tranzistor. Isprobajte simulaciju.</p>

<div style="text-align: center;">
<canvas id="CMOSInverterCanvas" width="500" height="300" style="border: solid 1px black"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Leon Luttenberger</span>
</div>

<script>
(function(){
    var canvas = document.getElementById("CMOSInverterCanvas");
    var context = canvas.getContext("2d");

    var circuit = new CMOSInverterCircuit(5);
    var truthTable = new TruthTable('1', '0', true);
    var input;

    var lineLength = 30;
    var inputSize = 25;
    var fontSize = 18;

    repaint();

    canvas.addEventListener("click", function (e) {
        var pos = getMousePos(canvas, e);

        if (input.containsPoint(pos.x, pos.y)) {
            circuit.setInput(!circuit.input);
            repaint();
        }
    }, false);

    function repaint() {
        context.clearRect(0, 0, canvas.width, canvas.height);

        context.beginPath();
        circuit.draw(context, 100, 25, 150, 250);

        context.beginPath();
        context.moveTo(circuit.inputConnector.x, circuit.inputConnector.y);
        context.lineTo(circuit.inputConnector.x - lineLength, circuit.inputConnector.y);
        context.stroke();

        var x = circuit.inputConnector.x - lineLength - inputSize;
        input = new Rectangle(x, circuit.inputConnector.y - inputSize / 2, inputSize, inputSize);

        context.strokeStyle = "black";
        context.fillStyle = "gray";
        context.textBaseline = "middle";
        context.textAlign = "center";

        context.beginPath();
        input.draw(context, true);

        context.fillStyle = "black";
        context.font =  fontSize + 'px Arial';

        var value = circuit.input ? 1 : 0;
        context.fillText(
                value + '',
                input.x + input.width / 2,
                input.y + input.height / 2
        );

        context.textAlign = "center";
        context.textBaseline = "bottom";
        context.fillText("A", circuit.inputConnector.x - lineLength / 2, circuit.inputConnector.y - 5);

        context.textAlign = "left";
        context.textBaseline = "middle";
        context.fillText(
                "f=" + (circuit.output ? '1' : '0'),
                circuit.outputConnector.x + 5,
                circuit.outputConnector.y
        );

        var selectedRow = circuit.input ? 1 : 0;
        context.beginPath();
        truthTable.draw(context, 325, 40, 150, 125, selectedRow);
    }

    canvas.addEventListener("click", function (e) {
        var pos = getMousePos(canvas, e);

        if (circuit.transistorRectangle.containsPoint(pos.x, pos.y)) {
            circuit.setInput(!circuit.input);
            repaint();
        }

    }, false);

    function CMOSInverterCircuit(sourceVoltage) {

        this.sourceVoltage = sourceVoltage;
        this.voltageF = undefined;

        this.input = undefined;
        this.output = undefined;

        this.inputConnector = undefined;
        this.outputConnector = undefined;

        this.setInput = function (value) {
            this.input = !!value;
            this.output = !this.input;

            if (this.input) {
                this.voltageF = 0;
            } else {
                this.voltageF = this.sourceVoltage;
            }
        };

        this.setInput(false);

        this.draw = function (context, xPos, yPos, boxWidth, boxHeight) {
            context.clearRect(xPos, yPos, boxWidth, boxHeight);
            window.clearTimeout(this.timeoutID);

            context.fillStyle = "black";
            context.strokeStyle = "black";
            context.lineWidth = 1;

            var transistorX = xPos + (3/7) * boxWidth;
            var voltageLineX = xPos + (5/7) * boxWidth;
            var transistorConnectionX = (xPos + transistorX) / 2;

            var pTransistorY = yPos + (1/4) * boxHeight;
            var nTransistorY = yPos + (3/4) * boxHeight;
            var outputY = yPos + (1/2) * boxHeight;

            var transistorHeight = outputY - pTransistorY;
            var transistorSpacing = boxWidth / 24;

            var connectionCircleRadius = 3;

            //draw lines
            context.beginPath();

            context.moveTo(xPos, nTransistorY);
            context.lineTo(transistorX - transistorSpacing, nTransistorY);

            context.moveTo(transistorConnectionX, nTransistorY);
            context.lineTo(transistorConnectionX, pTransistorY);

            context.moveTo(transistorConnectionX, pTransistorY);
            context.lineTo(transistorX - transistorSpacing, pTransistorY);

            context.moveTo(voltageLineX, yPos);
            context.lineTo(voltageLineX, pTransistorY - transistorHeight / 4);

            context.moveTo(voltageLineX, pTransistorY - transistorHeight / 4);
            context.lineTo(transistorX, pTransistorY - transistorHeight / 4);

            context.moveTo(transistorX, pTransistorY + transistorHeight / 4);
            context.lineTo(voltageLineX, pTransistorY + transistorHeight / 4);

            context.moveTo(voltageLineX, pTransistorY + transistorHeight / 4);
            context.lineTo(voltageLineX, nTransistorY - transistorHeight / 4);

            context.moveTo(voltageLineX, nTransistorY - transistorHeight / 4);
            context.lineTo(transistorX, nTransistorY - transistorHeight / 4);

            context.moveTo(transistorX, nTransistorY + transistorHeight / 4);
            context.lineTo(voltageLineX, nTransistorY + transistorHeight / 4);

            context.moveTo(voltageLineX, nTransistorY + transistorHeight / 4);
            context.lineTo(voltageLineX, yPos + boxHeight);

            context.moveTo(voltageLineX, outputY);
            context.lineTo(xPos + boxWidth, outputY);

            context.stroke();

            //draw transistors
            context.lineWidth = 2;

            var activeColor = "black";
            var inactiveColor = "lightgray";

            context.strokeStyle = this.input ? inactiveColor : activeColor;
            context.beginPath();

            context.moveTo(transistorX, pTransistorY - transistorHeight / 2);
            context.lineTo(transistorX, pTransistorY + transistorHeight / 2);

            context.moveTo(transistorX - transistorSpacing, pTransistorY - transistorHeight / 3);
            context.lineTo(transistorX - transistorSpacing, pTransistorY + transistorHeight / 3);

            context.stroke();

            context.strokeStyle = this.input ? activeColor : inactiveColor;
            context.beginPath();

            context.moveTo(transistorX, nTransistorY - transistorHeight / 2);
            context.lineTo(transistorX, nTransistorY + transistorHeight / 2);

            context.moveTo(transistorX - transistorSpacing, nTransistorY - transistorHeight / 3);
            context.lineTo(transistorX - transistorSpacing, nTransistorY + transistorHeight / 3);

            context.stroke();
            context.strokeStyle = "black";

            context.fillStyle = "white";
            (new Circle(transistorX - transistorSpacing - connectionCircleRadius, pTransistorY, connectionCircleRadius)).draw(context, true);
            context.fillStyle = "black";

            //draw grounding
            var groundSymbolWidth = boxWidth / 6;

            context.beginPath();
            context.moveTo(voltageLineX - groundSymbolWidth / 2, yPos + boxHeight);
            context.lineTo(voltageLineX + groundSymbolWidth / 2, yPos + boxHeight);
            context.stroke();

            context.lineWidth = 1;

            //draw voltage triangle
            var voltageTriangleHeight = (outputY - yPos) / 6;
            var voltageTriangleBase = voltageTriangleHeight / 2;
            var voltageTriangle = new Triangle(
                    voltageLineX,
                    yPos,
                    voltageLineX - voltageTriangleBase / 2,
                    yPos + voltageTriangleHeight,
                    voltageLineX + voltageTriangleBase / 2,
                    yPos + voltageTriangleHeight
            );

            voltageTriangle.draw(context, true);

            //draw connection circles
            (new Circle(transistorConnectionX, nTransistorY, connectionCircleRadius)).draw(context, true);
            (new Circle(voltageLineX, outputY, connectionCircleRadius)).draw(context, true);

            context.fillStyle = "white";
            (new Circle(xPos, nTransistorY, connectionCircleRadius)).draw(context, true);
            (new Circle(xPos + boxWidth, outputY, connectionCircleRadius)).draw(context, true);
            context.fillStyle = "black";

            //set up connection points
            this.inputConnector = new Point(xPos, nTransistorY);
            this.outputConnector = new Point(xPos + boxWidth, outputY);

            this.inputConnector.x -= connectionCircleRadius;
            this.outputConnector.x += connectionCircleRadius;

            //draw voltage values
            var fontSize = Math.min(boxHeight, boxWidth) / 9;
            context.font = fontSize + 'px Arial';
            context.fillStyle = "black";

            context.textBaseline = "middle";
            context.textAlign = "left";
            context.fillText(
                    this.sourceVoltage + 'V',
                    voltageLineX + voltageTriangleBase,
                    yPos + (voltageTriangleHeight / 2)
            );

            //draw voltage drops
            context.textBaseline = "middle";
            context.textAlign = "left";

            context.fillText(
                    this.voltageF + 'V',
                    (voltageLineX + xPos + boxWidth) / 2,
                    (outputY + yPos + boxHeight) / 2
            );
            drawArrowUp(
                    context,
                    (voltageLineX + xPos + boxWidth) / 2 - 2,
                    yPos + boxHeight - 10,
                    yPos + boxHeight - outputY - 20
            );

            context.fillText(
                    (this.sourceVoltage - this.voltageF) + 'V',
                    (voltageLineX + xPos + boxWidth) / 2,
                    (outputY + yPos) / 2
            );
            drawArrowUp(
                    context,
                    (voltageLineX + xPos + boxWidth) / 2 - 2,
                    outputY - 10,
                    outputY - yPos - 20 - fontSize
            );

            context.fillText(
                    (this.input ? this.sourceVoltage : 0) + 'V',
                    xPos + 10,
                    (nTransistorY + yPos + boxHeight) / 2
            );
            drawArrowUp(
                    context,
                    xPos + 5,
                    yPos + boxHeight - 10,
                    (yPos + boxHeight - nTransistorY) - 20
            );

            //draw transistor terminals symbols
            var terminalsFontSize = fontSize / 1.5;
            context.font = terminalsFontSize + 'px Arial';

            context.textBaseline = "bottom";
            context.textAlign = "right";
            context.fillText(
                    'G',
                    transistorX - transistorSpacing - connectionCircleRadius - 2,
                    pTransistorY - 2
            );
            context.fillText(
                    'G',
                    transistorX - transistorSpacing - connectionCircleRadius - 2,
                    nTransistorY - 2
            );

            context.textBaseline = "bottom";
            context.textAlign = "left";
            context.fillText(
                    'S',
                    transistorX + 2,
                    pTransistorY - transistorHeight/4 - 2
            );
            context.fillText(
                    'D',
                    transistorX + 2,
                    nTransistorY - transistorHeight/4 - 2
            );

            context.textBaseline = "top";
            context.textAlign = "left";
            context.fillText(
                    'D',
                    transistorX + 2,
                    pTransistorY + transistorHeight/4 + 2
            );
            context.fillText(
                    'S',
                    transistorX + 2,
                    nTransistorY + transistorHeight/4 + 2
            );

            context.font = fontSize + 'px Arial';
        }
    }
})();
</script>

<p>Vrlo značajno svojstvo ovakve implementacije invertora je da kroz njega u statičkim uvjetima, dok je napon na ulazu stabilan, struja nikada ne teče od napajanja prema masi kroz
   tranzistore, jer je uvijek jedan od njih blokiran. Struja će teći u kratkim šiljcima u trenutcima kada dolazi do promjene, pa se jedan treba usključiti a onaj drugi isključiti. Ako
   se prvi uključi prije no što se drugi isključi, kratko vrijeme postojat će otvoren put niskog otpora od napajanja prema masi i kratkotrajno će poteći struja većeg iznosa.</p>

<p>Simboli koje smo ovdje koristili za n-kanalni MOSFET i p-kanalni MOSFET oba su "logički" simboli. Simbol p-kanalnog MOSFET-a ima uz upravljačku elektrodu mali kružić koji u logičkom
   smislu predstavlja invertor i koji nam govori da je ovaj tranzistor uključen kada mu je na upravljačkoj elektrodi logička nula (odnosno niska naponska razina).</p>


